%
% BoundedNormalDistribution.m
%

classdef BoundedNormalDistribution < NormalDistribution

  properties (SetAccess = private)
    LowerBound
    UpperBound
  end

  methods (Access = public)

    function this = BoundedNormalDistribution(mean, variance, lowerBound, upperBound)
      this = this@NormalDistribution(mean, variance);
      this.LowerBound = lowerBound;
      this.UpperBound = upperBound;
    end

    function result = Random(this)
      result = -Inf;
      while result < this.LowerBound || this.UpperBound < result
        result = Random@NormalDistribution(this);
      end
    end

  end

end
