%
% GenericSpline.m
% 
% spapi を用いた、多次元対応 Spline 補間
%   xGrids: グリッドの次元毎の値の配列を、セル配列で与える
%   yArray: 各グリッド点における値を、多次元配列で与える
%   result: 補間された関数
%
function result = GenericSpline(xGrids, yArray)
  knots = num2cell(repmat(3, 1, length(xGrids))); % TODO knots
  if size(xGrids, 2) == 1
    y = yArray';
  else
    y = yArray;
  end
  sp = spapi(knots, xGrids, y);
  result = @(x) (fnval(sp, x));
end
