%
% MCDCInput.m
%
classdef MCDCInput < handle
  
  properties (Access = public)
    
    xGrids
    stateKernelGens
    obsKernelGens
    stateMeanFuncs
    obsMeanFuncs
    gridDimForGramMatrix
    splineHandle
    x0
    xaux
    u
    z
    N
    J
    K
    
  end
  
  methods (Access = public)
    
    function this = MCDCInput(xGrids, ...
                              stateKernelGens, obsKernelGens, ...
                              stateMeanFuncs, obsMeanFuncs, ...
                              gridDimForGramMatrix, ...
                              splineHandle, ...
                              x0, xaux, u, z, N, J, K)
      this.xGrids = xGrids;
      this.stateKernelGens = stateKernelGens;
      this.obsKernelGens = obsKernelGens;
      this.stateMeanFuncs = stateMeanFuncs;
      this.obsMeanFuncs = obsMeanFuncs;
      this.gridDimForGramMatrix = gridDimForGramMatrix;
      this.splineHandle = splineHandle;
      this.x0 = x0;
      this.xaux = xaux;
      this.u = u;
      this.z = z;
      this.N = N;
      this.J = J;
      this.K = K;
    end
    
    function result = XDim(this)
      result = size(this.x0, 2);
    end
    
    function result = YDim(this)
      result = size(this.z, 1);
    end
    
    function result = T(this)
      result = size(this.z, 2);
    end
    
  end
  
end
