%
% MCDCStrategyChoice1.m
%

classdef MCDCStrategyChoice1 < MCDCStrategy

  methods (Access = public)

    function this = MCDCStrategyChoice1(algorithm)
      this = this@MCDCStrategy(algorithm)
      this.particleFilter = @PMMHParticleFilter;
    end

    function result = StateMean(this, j, in, out)
      if j == 1
        gridPoints = this.gridData.GetFlatMatrix();
        dims = [size(in.stateMeanFuncs, 2) this.gridData.CountPerDim];
        this.initialStateMean = zeros(dims);
        for d = 1:dims(1)
          this.initialStateMean(d, :) = in.stateMeanFuncs{d}(gridPoints);
        end
      end
      result = this.initialStateMean;
    end

    function result = ObsMean(this, j, in, out)
      if j == 1
        gridPoints = this.gridData.GetFlatMatrix();
        dims = [size(in.obsMeanFuncs, 2) this.gridData.CountPerDim];
        this.initialObsMean = zeros(dims);
        for d = 1:dims(1)
          this.initialObsMean(d, :) = in.obsMeanFuncs{d}(gridPoints);
        end
      end
      result = this.initialObsMean;
    end

    function result = StateSigma(this, j, gramMatrix)
      result = gramMatrix;
    end

    function result = ObsSigma(this, j, gramMatrix)
      result = gramMatrix;
    end

    function result = AcceptanceLogProbability(this, j, in, out, logLikelihood, stateVals, obsVals, gramMatState, gramMatObs)
      if j == 1
        result = 0;
      else
        result = this.LikelihoodContribution(j, out, logLikelihood);
      end
    end

  end

  methods (Access = private)

    function result = LikelihoodContribution(this, j, out, logLikelihood)
      result = logLikelihood - out.loglikAt(j - 1);
    end

  end

end
