%
% PMMHParticleFilter.m
%

classdef PMMHParticleFilter < ParticleFilter

  methods (Access = public)
    
    function this = PMMHParticleFilter(x0, xaux, u, y, f, h, q, r, N, K)
      this = this@ParticleFilter(x0, xaux, u, y, f, h, q, r, N, K);
      
      T = size(y, 1);
      % Generate the trajectories from ancestor indices
      ind = this.ancestorIndicies(:, T);
      for(t = T-1:-1:1)
          this.Particles(:, t) = this.Particles(ind, t);
          ind = this.ancestorIndicies(ind, t);
      end
    end
    
  end

end
