%
% UniformDistribution.m
%
classdef UniformDistribution < Distribution
  
  properties (SetAccess = private)
    LowerBound
    UpperBound
  end
  
  methods (Access = public)
    
    function this = UniformDistribution(lowerBound, upperBound)
      this.LowerBound = lowerBound;
      this.UpperBound = upperBound;
    end
    
    function result = Random(this)
      result = this.LowerBound + (this.UpperBound - this.LowerBound) * rand();
    end
    
  end
  
end
