%
% MotionCapturePMMH2Test.m
%

rng('shuffle');

files = dir('data/amc_files/*.amc');
models = dir('logs/*_200.mat');

N = 500;

for file = files'

  amcFile = ['data/amc_files/' file.name];
  amcId = strsplit(file.name, '.');
  amcId = amcId{1};

  [x, y] = MotionCapture(amcFile, 1:3, 1:3);

  for model = models'

    modelFile = ['logs/' model.name];
    modelId = strsplit(model.name, '_');
    modelId = [modelId{1} '_' modelId{2}];

    outputFileBase = ['logs.test/' amcId '_' modelId];

    aspect = Aspect();
    aspect.LogFileName = [outputFileBase '.log'];

    aspect.Log('Testing %s: model = %s\n', char(amcId), char(modelId));

    [result, F, G] = MCDCTest( ...
      []', ...
      y', ...
      N, ...
      modelFile ...
    );

    outputFile = [outputFileBase '.mat'];
    save(outputFile);

  end

end
