%
% VectorValuedFunctionTest.m
%

%
% Conversions from polar to X-Y, respectively.
%

functions{1} = @(v) v(1,:) .* cos(v(2,:));
functions{2} = @(v) v(1,:) .* sin(v(2,:));

polarToXY = VectorValuedFunction(functions);

%
% Testing.
%

radius   = linspace(0, 10, 100)';
angle    = linspace(0, 2 * pi(), 100)';
xyValues = polarToXY([radius angle]);

%
% Check the maximum error.
%

max(sqrt(sum((xyValues - [(radius .* cos(angle)) (radius .* sin(angle))]) .^ 2, 2)))

quit;

